#include "alloc.h"
#include <stdio.h>
#include <stdlib.h>

void* alloc_or_crash(size_t size) {
    void *mem = malloc(size);
    if(!mem) {
        fprintf(stderr, "Error: failed to allocate %zu bytes\n", size);
        abort();
    }
    return mem;
}

void* realloc_or_crash(void *mem, size_t new_size) {
    void *new_mem = realloc(mem, new_size);
    if(!new_mem) {
        fprintf(stderr, "Error: failed to reallocate %p to size %zu\n", mem, new_size);
        abort();
    }
    return new_mem;
}
